#!/bin/bash

set -e

tmp=$(mktemp -d)

trap cleanup EXIT
cleanup() {
    set +e
    [ -z "$tmp" -o ! -d "$tmp" ] || rm -rf "$tmp"
}

unset CDPATH
pwd=$(pwd)
cvs=$(date +%Y%m%d)cvs
name=tritonus

cd "$tmp"
cvs -z3 -d:pserver:anonymous@$name.cvs.sourceforge.net:/cvsroot/$name export -D $(date +%Y%m%d) $name
# Remove patent encumbered parts
find . -iname "*mp3*" |xargs rm -fr -- || :
find . -iname "*mpeg*" |xargs rm -fr -- || :
find . -name lame | xargs rm -fr -- || :
version=$(cat $name/version)
mv $name $name-$version
tar jcf "$pwd"/$name-$version-$cvs.tar.bz2 $name-$version

echo "Written: $name-$version-$cvs.tar.bz2"
cd - >/dev/null
