%global cvs_version 20101108cvs

Name:           tritonus
Summary:        Java Sound API Implementation
URL:            http://www.tritonus.org/
Group:          System Environment/Libraries
Version:        0.3.7
Release:        0.28.%{cvs_version}%{?dist}
License:        LGPLv2+
Source0:        %{name}-%{version}-%{cvs_version}.tar.bz2
Source9:        %{name}-snapshot.sh
# Remove lame and ioctl bits:
Patch0:         %{name}-configure.in.diff
# Make trinotus compile against the latest version of these libraries:
Patch1:         %{name}-src-lib-fluidsynth.Makefile.in.diff
Patch2:         %{name}-no-jlayer.patch
Patch3:         %{name}-src-lib-alsa-constants_check.h.diff
Patch4:         %{name}-removed-code.diff
# Fix alsa midi crash RHBZ #510063
# http://sourceforge.net/tracker/?func=detail&aid=2818404&group_id=1390&atid=201390
Patch5:         %{name}-src-lib-alsa-cast.patch
Patch6:         %{name}-openjdk-1-7-support.diff
Patch7:         tritonus-0.3.7-nonascii.patch
Patch8:         tritonus-0.3.7-bytecode-version.patch

BuildRequires:  alsa-lib-devel
BuildRequires:  ant
BuildRequires:  ant-commons-net
BuildRequires:  cdparanoia-devel
BuildRequires:  fluidsynth-devel
BuildRequires:  java-devel java-headless
BuildRequires:  jorbis
BuildRequires:  jpackage-utils
BuildRequires:  libtool
BuildRequires:  libvorbis-devel
BuildRequires:  libvorbis-devel
Requires:       java-headless
Requires:       jpackage-utils
Requires:       jorbis

Provides:       %{name}-shared = %{version}-%{release}

# Packages merged into the tritonus package
Provides:       tritonus-core = %{version}-%{release}
Provides:       tritonus-aos = %{version}-%{release}
Provides:       tritonus-javasequencer = %{version}-%{release}
Provides:       tritonus-misc = %{version}-%{release}
Provides:       tritonus-alsa = %{version}-%{release}
Provides:       tritonus-dsp = %{version}-%{release}
Provides:       tritonus-jorbis = %{version}-%{release}
Provides:       tritonus-pvorbis = %{version}-%{release}
Provides:       tritonus-vorbis = %{version}-%{release}
Provides:       tritonus-src = %{version}-%{release}
Provides:       tritonus-esd = %{version}-%{release}
Obsoletes:      tritonus-core < %{version}-%{release}
Obsoletes:      tritonus-aos < %{version}-%{release}
Obsoletes:      tritonus-javasequencer < %{version}-%{release}
Obsoletes:      tritonus-misc < %{version}-%{release}
Obsoletes:      tritonus-alsa < %{version}-%{release}
Obsoletes:      tritonus-dsp < %{version}-%{release}
Obsoletes:      tritonus-jorbis < %{version}-%{release}
Obsoletes:      tritonus-pvorbis < %{version}-%{release}
Obsoletes:      tritonus-vorbis < %{version}-%{release}
Obsoletes:      tritonus-src < %{version}-%{release}
Obsoletes:      tritonus-esd < %{version}-%{release}

%description
Tritonus is an implementation of the Java Sound API. This package contains
common files and shared classes required by all other Tritonus plug-ins plus
support for aos, javasequencer, alsa, dsp, gsm, jorbis, pvorbis and vorbis.

%package cdda
Summary:    A plug-in for Java that enables you to digitally read audio CD's
Group:      System Environment/Libraries
Requires:   %{name}-shared = %{version}-%{release}

%description cdda
A plug-in for Java that enables you to digitally read audio CD's.

%package fluidsynth
Summary:    Plug-in for fluidsynth
Group:      System Environment/Libraries
Requires:   %{name}-shared = %{version}-%{release}

%description fluidsynth
A tritonus plug-in for fluidsynth.

%package gsm
Summary:    GSM codec
License:    GPLv2+
Group:      System Environment/Libraries
Requires:   %{name}-shared = %{version}-%{release}

%description gsm
For examples of using the GSM codec, refer to the Java Sound Resources examples
GSMEncoder, AudioDecoder and DecodingAudioPlayer:
http://www.jsresources.org/
http://www.jsresources.org/examples/GSMEncoder.html
http://www.jsresources.org/examples/AudioDecoder.html
http://www.jsresources.org/examples/DecodingAudioPlayer.html

%package javadoc
Summary:    Javadocs for %{name}
Group:      Documentation
Requires:   %{name} = %{version}-%{release}
Requires:   jpackage-utils

%description javadoc
This package contains the API documentation for %{name}.

%prep
%setup -q
%patch0 -p1 -b .lameandioctl
%patch1 -p0 -b .oldapi
%patch2 -p1
%patch3 -p0 -b .oldapi
%patch4 -p1 -b .oldapi
%patch5 -p1 -b .cast
%patch6 -p1
%patch7 -p0
%patch8 -p0

# Fix encoding issues
for file in doc/{compression.txt,TODO-matthias.txt,tritonusfaq.sgml}; do
    iconv -f iso-8859-1 -t utf8 $file > $file.tmp
    touch -r $file $file.tmp
    mv -f $file.tmp $file
done

# Remove classpath from manifest
sed -i '/Class-Path/d' build-common.xml

# Fedora doesn't like usage of System.loadLibrary
sed -i 's|System.loadLibrary("\(.*\)")|System.load("%{_libdir}/%{name}/lib\1.so")|' `grep -rl loadLibrary *`

# Fix compiler flags
sed -i -e 's|-Werror||g' \
    -e 's|-Wl,-rpath,/home/matthias/java/tritonus/src/lib/common||g' \
    `find . -name Makefile.in`

# Prevent a rebuild in %%install
sed -i 's|install: all|install:|' Makefile.in

autoreconf -fi


%build
export CFLAGS="$RPM_OPT_FLAGS -fPIC -I%{_includedir}/cdda"
export CPPFLAGS="$RPM_OPT_FLAGS -fPIC -I%{_includedir}/cdda"
export CXXFLAGS="$RPM_OPT_FLAGS -fPIC -I%{_includedir}/cdda"
%configure

export CLASSPATH=`build-classpath commons-net`
%ant -v -f build-dtd.xml
# I don't know why these lines stop the building of tritonus:
sed -i -e '/timestampgranularity/d' -e '/serverlanguagecodeconfig/d' project.dtd

export CLASSPATH=`build-classpath jogg jorbis`
%ant

make %{?_smp_mflags} JAVADIR=%{_jvmdir}/java

# javadoc doesn't want to process these two files:
rm -f src/classes/org/tritonus/debug/AJDebug*
%javadoc -d javadoc -public -Xdoclint:none `find ./ -name '*.java'`


%install
make install \
    LIBS="" \
    JAVAEXTPATH=%{buildroot}%{_jnidir}%{name} \
    JAVAEXTLIBPATH=%{buildroot}%{_libdir}/%{name} \
    DESTDIR=%{buildroot}

# jars
install -dm 755 %{buildroot}%{_jnidir}/%{name}
install -pm 644 dist/*.jar %{buildroot}%{_jnidir}/%{name}
pushd %{buildroot}%{_jnidir}/%{name}
    for jar in *-%{version}*; do
        mv ${jar} `echo $jar| sed "s|-%{version}||g"`
    done
popd


# javadoc
install -dm 755 %{buildroot}%{_javadocdir}/%{name}
cp -pr javadoc/* %{buildroot}%{_javadocdir}/%{name}

# No need to have symlinks for JNI files
pushd %{buildroot}%{_libdir}/%{name}
    for sofile in *.so; do
        mv $sofile.1.0 $sofile
        rm -f $sofile.*
    done
popd

%files
%doc LGPL NEWS README doc/kaffe* doc/midi* doc/*TODO* doc/*proposal*
%doc doc/%{name}faq.sgml
%doc doc/AudioOutput*
%doc doc/ALSA* doc/Alsa* doc/bindists/alsa/readme.txt
%doc doc/compression*
%doc doc/bindists/vorbis/readme.txt
%dir %{_jnidir}/%{name}/
%{_jnidir}/%{name}/%{name}_share*.jar
%{_jnidir}/%{name}/%{name}_core*.jar
%{_jnidir}/%{name}/%{name}_aos*.jar
%{_jnidir}/%{name}/%{name}_javasequencer*.jar
%{_jnidir}/%{name}/%{name}_remaining*.jar
%{_jnidir}/%{name}/%{name}_alsa*.jar
%{_jnidir}/%{name}/%{name}_dsp*.jar
%{_jnidir}/%{name}/%{name}_jorbis*.jar
%{_jnidir}/%{name}/%{name}_pvorbis*.jar
%{_jnidir}/%{name}/%{name}_vorbis*.jar
%{_jnidir}/%{name}/%{name}_src*.jar
%exclude %{_jnidir}/%{name}/%{name}_esd*.jar
%dir %{_libdir}/%{name}
%{_libdir}/%{name}/lib%{name}alsa.so
%{_libdir}/%{name}/lib%{name}vorbis.so
%exclude %{_libdir}/%{name}/lib%{name}esd.so


%files cdda
%doc doc/cdda.txt doc/bindists/cdda/readme.txt
%{_libdir}/%{name}/lib%{name}cdparanoia.so
%{_jnidir}/%{name}/%{name}_cdda*jar

%files fluidsynth
%doc doc/fluidsynth*
%{_libdir}/%{name}/lib%{name}fluid.so
%{_jnidir}/%{name}/%{name}_fluidsynth*.jar

%files gsm
%doc doc/compression*
%{_jnidir}/%{name}/%{name}_gsm*jar

%files javadoc
%{_javadocdir}/%{name}


%changelog
* Fri Feb 05 2016 Fedora Release Engineering <releng@fedoraproject.org> - 0.3.7-0.28.20101108cvs
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Thu Sep 24 2015 Jon Ciesla <limburgher@gmail.com> - 0.3.7-0.27.20101108cvs
- Update bytecode in build-common.xml

* Tue Sep 22 2015 Jon Ciesla <limburgher@gmail.com> - 0.3.7-0.26.20101108cvs
- Fix FTBFS.
- Changelog date fixes.

* Sun Jul 12 2015 Peter Robinson <pbrobinson@fedoraproject.org> 0.3.7-0.25.20101108cvs
- Retire esound support

* Fri Jun 19 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.3.7-0.24.20101108cvs
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Mon Aug 18 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.3.7-0.23.20101108cvs
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Sun Jun 08 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.3.7-0.22.20101108cvs
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Fri Feb 21 2014 Jon Ciesla <limburgher@gmail.com> - 0.3.7-0.21.20101108cvs
- Switch to java-headless, BZ 1068538

* Sun Aug 04 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.3.7-0.20.20101108cvs
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Mon Mar 18 2013 Stanislav Ochotnicky <sochotnicky@redhat.com> - 0.3.7-0.19.20101108cvs
- Fix JNI installation directories and generic packaging cleanup

* Fri Feb 15 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.3.7-0.18.20101108cvs
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Wed Dec 19 2012 Stanislav Ochotnicky <sochotnicky@redhat.com> - 0.3.7-0.17.20101108cvs
- revbump after jnidir change

* Fri Jul 27 2012 Lukas Zapletal <lzap+rpm[@]redhat.com> - 0.3.7-0.16.20101108cvs
- support of OpenJDK 1.7

* Sun Jul 22 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.3.7-0.15.20101108cvs
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Sat Jan 14 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.3.7-0.14.20101108cvs
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Mon Mar 14 2011 Lukas Zapletal <lzap+rpm[@]redhat.com> - 0.3.7-0.13.20101108cvs
- bug 665576 - so files installed in /usr/lib(64)/java/tritonus

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.3.7-0.12.20101108cvs
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Mon Jan 17 2011 Lukas Zapletal <lzap+spec@redhat.com> - 0.3.7-0.11.20101108cvs
- bug 665426 - adding /usr/share/java symlinks

* Wed Jan 05 2011 Lukas Zapletal <lzap+spec@redhat.com> - 0.3.7-0.10.20101108cvs
- bug 665426 - adding symlinks to JNI dir

* Thu Nov 25 2010 Lukas Zapletal <lzap+spec@redhat.com> - 0.3.7-0.9.20101108cvs
- now fixing the last cosmetic issue (provide)

* Wed Nov 24 2010 Lukas Zapletal <lzap+spec@redhat.com> - 0.3.7-0.8.20101108cvs
- fixing last cosmetic issue

* Tue Nov 23 2010 Lukas Zapletal <lzap+spec@redhat.com> - 0.3.7-0.7.20101108cvs
- spec review by Hans de Goede
- fixing some spec cosmetic issues

* Thu Nov 11 2010 Lukas Zapletal <lzap+spec@redhat.com> - 0.3.7-0.6.20101108cvs
- removing tritonus-src-lib-alsa-Makefile.in.diff
- merging core, aos, javasequencer, misc, alsa, dsp, gsm, jorbis, pvorbis and vorbis
  into the main package

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.3.7-0.5.20090419cvs
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Wed Jul 08 2009 Orcan Ogetbil <oget[dot]fedora[at]gmail[dot]com> - 0.3.7-0.4.20090419cvs
- Fix alsa midi crash RHBZ #510063
- No more rebuilding in %%install

* Fri May 29 2009 Orcan Ogetbil <oget[dot]fedora[at]gmail[dot]com> - 0.3.7-0.3.20090419cvs
- Add disttag

* Thu May 07 2009 Orcan Ogetbil <oget[dot]fedora[at]gmail[dot]com> - 0.3.7-0.2.20090419cvs
- Fix duplicate files issue

* Sun Apr 19 2009 Orcan Ogetbil <oget[dot]fedora[at]gmail[dot]com> - 0.3.7-0.1.20090419cvs
- prepare the package for Fedora

* Thu Oct 16 2008 Alexander Kurtakov <akurtakov@mandriva.org> 0.3.7-0.0.cvs20080107.1mdv2009.1
+ Revision: 294485
- remove unneeded req
- really fix file list
- br libtool
- fix file list
- import tritonus
